// $Id: DateWidget.js,v 1.1 2009/10/07 22:23:31 jpmckinney Exp $

(function($) {

/**
 * @expects this.target to be a list.
 * @see apachesolr_date_facet_block()
 */
AjaxSolr.DateWidget = AjaxSolr.AbstractDateFacetWidget.extend({
  _handleResult: function() {
    AjaxSolr.theme('list_items', this.target, this.facetLinks());
  },

  facetLinks: function() {
    var links = [];

    var gap = this.facetDates ? this.facetDates.gap.substring(2) : 'YEAR';

    if (this.selectedItems.length) {
      var granularities = this.parts.slice(0, this.indexOfPart(gap));
      for (var i = 0; i < granularities.length; i++) {
        links.push(Drupal.theme('apachesolr_unclick_link', this.selectedItems[0][0].toDate().datePartString(granularities[i]), this.unclickHandler(this.selectedItems[0], granularities[i])));
      }
    }
    if (this.indexOfPart(gap) <= this.indexOfPart(this.granularity.toUpperCase())) {
      for (var facet in this.facetDates) {
        if (facet == 'end' || facet == 'gap' || facet == '_empty_' || this.facetDates[facet] == 0) continue;
        var value = this.getValue(facet, gap);
        links.push(Drupal.theme('apachesolr_facet_link', this.clickText(value), this.clickHandler(value), {}, this.facetDates[facet]));
      }
    }

    return links;
  }
});

})(jQuery);
