<?php
// $Id: apachesolr_ajax.reverse.inc,v 1.1 2009/10/07 22:23:31 jpmckinney Exp $

/**
 * @file
 * Implements reverse callbacks to go from human-readable values to internal
 * values. Necessary to transform an apachesolr_ajax-style URL into an
 * apachesolr-style URL. Otherwise, optional.
 */

/**
 * Reverse of apachesolr_search_get_book().
 * @see apachesolr_search_get_book()
 */
function apachesolr_ajax_reverse_is_book_bid($facet) {
  return db_result(db_query("SELECT nid FROM {node} WHERE title = '%s'", $facet));
}

/**
 * Reverse of locale_language_name().
 * @see locale_language_name()
 */
function apachesolr_ajax_reverse_language($facet) {
  if (module_exists('locale')) {
    static $list = NULL;
    if (!isset($list)) {
      $list = locale_language_list();
    }
    return array_search($facet, $list);
  }
}

/**
 * Reverse of apachesolr_search_get_username().
 * @see apachesolr_search_get_username()
 */
function apachesolr_ajax_reverse_uid($facet) {
  if ($facet == variable_get('anonymous', t('Anonymous'))) {
    return 0;
  }
  else {
    return db_result(db_query("SELECT uid FROM {users} WHERE name = '%s'", $facet));
  }
}

/**
 * Reverse of apachesolr_search_get_type().
 * @see apachesolr_search_get_type()
 */
function apachesolr_ajax_reverse_type($facet) {
  $type = array_search($facet, node_get_types('names'));
  return ($type === FALSE) ? $facet : $type;
}
